$ CREATE SYS$MANAGER:MONITOR.TMP
$ DECK
$ DEFINE SLEEP_TIME "0 1:10:0.0"
$ SET PROC/PRIV=NOEXQUOTA/NAME=MONITOR
$ ON ERROR THEN CONTINUE
$10:
$ @SYS$MANAGER:SHUFQUE QUICK$BATCH
$ @SYS$MANAGER:SHUFQUE SYS$BATCH
$ @SYS$MANAGER:SHUFQUE LONG$BATCH
$ A = F$TIME()
$ HOUR = F$INTEGER(F$EXTRACT(12,2,A))
$ IF HOUR.GT.4 THEN GOTO 20
$ STOP/QUEUE QUICK$BATCH
$ START/QUEUE/JOB=1 QUICK$BATCH
$ @SYS$MANAGER:MANIPQUE QUICK$BATCH [202,010] RELEASE
$! IF HOUR.GT.2 THEN STOP/QUEUE MRB$BATCH
$ GOTO 30
$20:
$ IF HOUR.LT.18 THEN GOTO 30
$ @SYS$MANAGER:MANIPQUE QUICK$BATCH [202,010] HOLD
$ STOP/QUEUE QUICK$BATCH
$ START/QUEUE/JOB=2 QUICK$BATCH
$! STOP/QUEUE MRB$BATCH
$! START/QUEUE MRB$BATCH
$30:
$ SH SYSTEM
$ SH MEMORY
$ ON WARNING THEN LOGOFF/BRIEF
$ RUN X$:SLEEPSOME
$ ON ERROR THEN CONTINUE
$ GOTO 10
$ EOD
$ RUN SYS$SYSTEM:LOGINOUT/INPUT=SYS$MANAGER:MONITOR.TMP-
/OUTPUT=SYS$MANAGER:MONITOR.OUT/ERROR=SYS$MANAGER:MONITOR.OUT-
/PRIVILEGES=(NOCMKRNL,NOCMEXEC,NOSYSNAM,NOGRPNAM,NOALLSPOOL,-
DETACH,NODIAGNOSE,NOLOG_IO,NOGROUP,NOACNT,NOPRMCEB,NOPRMMBX,-
NOPSWAPM,NOALTPRI,NOSETPRV,TMPMBX,WORLD,OPER,NOEXQUOTA,-
NONETMBX,NOVOLPRO,NOPHY_IO,NOBUGCHK,NOPRMGBL,NOSYSGBL,-
NOMOUNT,NOPFNMAP,NOSHMEM,SYSPRV,NOBYPASS)/PRIORITY=5-
/NORESOURCE_WAIT/UIC=[1,4]/NOAUTHORIZE/PROCESS_NAME=MONITOR
$ WAIT 0:0:2
$ DELETE SYS$MANAGER:MONITOR.TMP;0
$EXIT
