$	SET NOVERIFY
$!
$!===========================================================================
$!
$!		SYSTEM LOGIN COMMAND PROCEDURE
$!		SYS$MANAGER:SYSLOGIN.COM
$!
$!			REVISION HISTORY:
$!
$!			DATE:			INITIALS
$!			-----			--------
$!
$!			22 November  1982	EAF - Development
$!			24 November  1982	EAF - Incl new symbols
$!			29 November  1982	EAF - Incl symbol "RJE"
$!			 7 January   1983	EAF - Incl job number display for batch jobs,
$!						EAF -      diskquota display,
$!						EAF -      username/UIC/system version display,
$!						EAF -      symbol LO* equivalenced to SYS$MANAGER:SYSLOGOUT.COM
$!			10 February  1983	EAF - Incl User function restrictions
$!			 3 September 1983       JLG - Add symbols.
$!===========================================================================
$!
$	SET CONTROL=T
$	SET NOCONTROL=Y
$	ON ERROR THEN GOTO EXIT
$!
$!		DEFINE ANY SYSTEM GLOBAL SYMBOLS
$!
$	BQ		:== SHOW QUEUE/ALL/BATCH
$	CPS_PLOT	:== SUBMIT/NOTIFY/KEEP/QUEUE=PLOTS SYS_UTIL:CPSPLOT/PARA=
$ 	DEF 		:== @SYS_UTIL:DEF
$       DIGI*CALC       :== @DIG$WORLD:DIGICALC.COM
$ 	DIR 		:== DIRECTORY/SIZE=ALL/PROT/OWNER
$ 	DIRB 		:== DIRECTORY/BRIEF
$ 	DIRC 		:== DIRECTORY/SIZE=ALL/DATE=CRE/OWNER
$ 	DIRF 		:== DIRECTORY/FULL
$ 	DIRM 		:== DIRECTORY/SIZE=ALL/DATE=MOD/OWNER
$	DISPL*AY	:== MONITOR PROCESS/TOPCPU
$ 	EDT 		:== EDIT/EDT
$	EDTCAI 		:== $EDTCAI
$	EXE		:== SET DEFAULT SYS$SYSTEM
$	FDL		:== EDIT/FDL
$	FILES		:== SHOW DEVICE/FILE
$	FOR*TRAN	:=  FOR
$	FREE		:== SHOW DEVICE/BR DR
$	GLOBALS		:== SHOW SYMBOL/GLOBAL/ALL
$	HOME		:== SET DEFAULT SYS$LOGIN
$	INFO		:== SHOW PROCESS/CONTINUOUS
$	LIB		:== SET DEFAULT SYS$LIBRARY
$ 	LO*GOUT		:== @SYS$MANAGER:SYSLOGOUT.COM
$ 	MAKE 		:== $SYS$SYSTEM:TECO MAKE
$	MEM		:== SHOW MEMORY
$	MGR		:== SET DEFAULT SYS$MANAGER
$ 	PARSE 		:== RUN SYS_UTIL:PARSE
$       PLOT            :== SUBMIT/NOTIFY/KEEP/QUEUE=PLOTS SYS_UTIL:PLOT/PARA=
$	PLT		:== SUBMIT/NOTIFY/KEEP/QUEUE=PLOTS SYS_UTIL:PLTDEF/PARA=
$	PRI		:== RUN SYS_UTIL:PRI
$ 	PROC 		:== SHOW PROCESS
$	QCP_PLOT	:== @SYS_UTIL:QCPPLOT
$	RJE		:== SUBMIT/QUEUE=RJE/NOTIFY SYS$MANAGER:RJE/PARA=
$	SOS		:== EDIT/SOS/READ
$	SUB		:== SUBMIT/KEEP/NOTIFY
$	SYS		:== SHOW SYSTEM
$	TALK		:== PHONE
$ 	TAPEM*ENU 	:== RUN SYS_UTIL:TAPEMENU
$	TE*CO		:== $SYS$SYSTEM:TECO TECO
$	UPD		:== SET DEFAULT SYS$UPDATE
$	UP		:== SET DEFAULT [-]
$	USERS		:== SHOW USERS
$	WAVELET		:== @SYS_UTIL:WAVELET
$!
$!
$!		DEFINE RMS/RSX-11 UTILITIES
$!
$	RMSDEF		:== MCR DEF
$	RMSDFN		:== MCR DFN
$	RMSDSP		:== MCR DSP
$	RMSIFL		:== MCR IFL
$	RMSBCK		:== MCR BCK
$	RMSRST		:== MCR RST
$	TKB		:== MCR TKB
$	PIP		:== MCR PIP
$	FLX		:== MCR FLX
$!
$ BATCH:
$ INTERACTIVE:
$ NETWORK:
$	SET PROT=(SYSTEM:RWED,OWNER:RWED,GROUP:R,WORLD:R)/DEFAULT
$	IF "''F$MODE()'" .EQS. "BATCH" THEN - 
		WRITE SYS$OUTPUT "Process ''F$PROCESS()' started at ''F$TIME()'"
$	WRITE SYS$OUTPUT " "
$	USERNAME = F$GETJPI("","USERNAME")				! get username
$	USERNAME = F$EXTRACT(0,F$LOCATE(" ",USERNAME),USERNAME)		! username with no embedded blanks
$	VERSION = F$EXTRACT(0,5,F$GETSYI("VERSION"))			! get version of VMS
$	WRITE SYS$OUTPUT "User ''USERNAME' UIC ''F$USER()' logged into VAX/VMS ''VERSION' ''F$TIME()'"
$	REQUEST "''F$MODE()' User ''USERNAME' logged in at ''F$TIME()'"	! write login time to operator log
$	@SYS$MANAGER:RESTRICT "''USERNAME'"				! get users restrictions
$	SHOW QUOTA							! display disk usage for user
$	IF F$SEARCH("SYS$LOGIN:LOGIN.COM") .EQS. "" THEN GOTO EXIT	! if no login file return to VMS
$	@LOGIN								! execute user login file
$!
$!
$!		EXIT THIS PROCEDURE
$!
$	EXIT:
$		SET CONTROL_Y
$		EXIT				! RETURN TO VMS
