$ VFL = 'F$VERIFY(0)
$ GOTO START
$!
$!	SET DEFAULT DIRECTORIES
$!    
$!	Modified extensively for use on the K105 VAX-11/782 at the
$!	NAVAL SURFACE WEAPONS CENTER, DAHLGREN, VIRGINIA  22448 by
$!	Alan L. Zirkle, NSWC Code K105, (703) 663-7815.
$!
$! Previous Implementors:
$!	Tom Kent/Rick Bryan	MIT/LCS		June, 1979
$!	Vicki			   ?		13-aug-1979
$!	Stan Knutson		MIT/JCF		  9/7/79 
$!	Richard L. Bryan	MIT/LCS		    ?
$!
$ START:
$	DONE = "DONE"
$	SYSDEVICE = F$LOGICAL("SYS$SYSDEVICE")
$	IF "''SD_SP'" .EQS. "" THEN GOTO INIT_STACK   ! First time SD called?
$!
$ RESTART:
$	DEFDIRECT = F$DIRECTORY()
$	DESTINATION = F$LOGICAL("SYS$DISK")
$	PP = F$EXTRACT(0,1,P1)
$!
$	IF PP .EQS. "."     THEN GOTO POINT
$	IF PP .EQS. "^"     THEN GOTO UP
$	IF PP .EQS. ">"     THEN GOTO ACROSS
$	IF PP .EQS. "<"     THEN GOTO POP
$	IF P1 .EQS. ""      THEN GOTO 'DONE'
$	IF P1 .EQS. "*"     THEN GOTO STAR
$	IF P1 .EQS. "?"     THEN GOTO HELP
$	IF P1 .EQS. "/HELP" THEN GOTO HELP
$	IF P1 .EQS. "HELP"  THEN GOTO HELP			! LOCAL *******
$!
$	IF P1 .NES. F$STRING(F$INTEGER(P1)) THEN  GOTO COMBINE
$	P1 = "SD__" + P1
$	P1 = &P1
$!
$ COMBINE:
$	IF P2 .EQS. "*" .OR. P2 .EQS. "DIR" THEN  GOTO CHECK_DEV
$	P1 = P1 + P2
$	P2 = P3
$	P3 = ""
$!
$ CHECK_DEV:
$	OLD = P1
$	IF F$LOGICAL(P1) .NES. "" THEN P1 = F$LOGICAL(P1)
$	COL = F$LOCATE(":",P1)
$	IF COL .EQ. F$LENGTH(P1) THEN GOTO NOCOLON
$	DISK = F$EXTRACT(0,COL,P1) - ":"
$	IF F$EXTRACT(0,1,DISK).EQS."_" THEN DISK = DISK - "_"	! (optional)
$	P1 = F$EXTRACT(COL+1,255,P1)
$	IF DISK .EQS. "" THEN GOTO NOCOLON
$	IF F$LOCATE(DISK,SYSDEVICE) .LE. 2 THEN DISK = "SYS$SYSDEVICE"
$	IF DISK.EQS."DRA5" THEN -				! LOCAL *******
			IF F$LOGICAL("DISK5").NES."" -		! LOCAL *******
					 THEN DISK = "DISK5"	! LOCAL *******
$	IF DISK.EQS."_DRC0" THEN DISK = OLD			! LOCAL *******
$	DESTINATION = DISK + ":"
$	IF P1 .EQS. "" THEN GOTO TEST
$!
$ NOCOLON:
$	P1 = P1 - "[" - "]"
$	IF F$LOCATE(".",P1) .EQ. 0 THEN GOTO DOWN
$	DESTINATION = DESTINATION + "[" + P1 + "]"
$	GOTO TEST
$!-------------------------------------------------------
$ ACROSS:
$	REST = P1 - ">"
$	IF F$EXTRACT(0,1,REST) .NES. "." THEN  REST= "." + REST
$	GOTO UPTEST
$!-------------------------------------------------------
$ UP:
$	REST = ""
$ UPTEST:
$	COL = F$LOCATE(".",DEFDIRECT)
$	END = F$LENGTH(DEFDIRECT)
$	IF COL .EQ. END THEN  GOTO 'DONE'
$	IF F$EXTRACT(0,2,P1) .EQS. "^^" THEN  GOTO UPEND
$	COL = END
$ UPLOOP:
$	COL = COL - 1
$	IF F$EXTRACT(COL,1,DEFDIRECT) .NES. "." THEN  GOTO UPLOOP
$ UPEND:
$	DESTINATION = DESTINATION + F$EXTRACT(0,COL,DEFDIRECT) + REST + "]"
$	GOTO TEST
$!-------------------------------------------------------
$ POINT:
$	IF P1 .NES. "." THEN  GOTO DOWN
$	DESTINATION = F$LOGICAL("SYS$LOGIN")
$	GOTO TEST
$!-------------------------------------------------------
$ DOWN:
$	DESTINATION = DESTINATION + (DEFDIRECT - "]" + P1 + "]")
$	GOTO TEST
$!-------------------------------------------------------
$ POP:
$	IF P1 .EQS. "<<" THEN GOTO STACK_LIST
$	SD_X = P1 - "<"
$	IF SD_X .EQS. "" THEN SD_X = 1
$	DESTINATION = "SD_SLOT" + F$STRING((SD_SP-SD_X).AND.7)
$	DESTINATION = &DESTINATION
$	GOTO TEST
$!-------------------------------------------------------
$ INIT_STACK:
$	SD_SLOT0 == F$LOGICAL("SYS$DISK") + F$DIRECTORY()
$	SD_SP == 1
$ INIT_LOOP:
$	SD_SLOT'SD_SP == F$LOGICAL("SYS$LOGIN")
$	SD_SP == (SD_SP + 1) .AND. 7
$	IF SD_SP .NE. 0 THEN GOTO INIT_LOOP
$!
$	IF "''SD__0'" .EQS. "" THEN SD__0 == "SYS$SYSDEVICE:"	! LOCAL *******
$	IF "''SD__1'" .EQS. "" THEN SD__1 == "DRA5:"		! LOCAL *******
$	IF "''SD__3'" .EQS. "" THEN SD__3 == "DISK3:"		! LOCAL *******
$	GOTO RESTART
$!-------------------------------------------------------
$ STACK_LIST:
$	WRITE SYS$OUTPUT "
   [7m SD's Directory Stack [m
"
$	SP = SD_SP
$	N = 0
$	PREFIX = "[7mcur[m "
$ STACK_LOOP:
$	WRITE SYS$OUTPUT PREFIX,SD_SLOT'SP
$	SP = (SP - 1) .AND. 7
$	IF SP .EQ. SD_SP THEN GOTO STACK_END
$	N = N + 1
$	PREFIX = "<" + F$STRING(N) + "  "
$	GOTO STACK_LOOP
$ STACK_END:
$	WRITE SYS$OUTPUT " "
$	GOTO END
$!-------------------------------------------------------
$ STAR:
$	RUN SYS$SYSDEVICE:[VAX83C.NSWC]SD			! LOCAL *******
$	GOTO END
$!-------------------------------------------------------
$ HELP:
$	DEASSIGN SYS$INPUT
$	HELP /LIBRARY=SYS$SYSDEVICE:[VAX83C.NSWC]SD  SD 'P2 'P3	! LOCAL *******
$	GOTO END
$!-------------------------------------------------------
$!	Check to see if the destination directory really exists.
$ TEST:
$	NEWDEV = F$PARSE(DESTINATION,,,"DEVICE") - ":"
$	WRKDEV = NEWDEV
$	NEWDIR = F$PARSE(DESTINATION,,,"DIRECTORY") - "[" - "]"
$	IF F$LOCATE(".",NEWDIR) .EQ. F$LENGTH(NEWDIR) THEN GOTO AT_MASTER
$	COL = F$LENGTH(NEWDIR)
$ TLOOP:
$	COL = COL - 1
$	IF F$EXTRACT(COL,1,NEWDIR) .NES. "." THEN  GOTO TLOOP
$	WRKDIR = NEWDIR
$	WRKDIR[COL,1] := "]"
$	GOTO SEARCH
$!
$ AT_MASTER:
$	IF NEWDEV.EQS."".OR.NEWDIR.EQS."" THEN  GOTO SYNTAX
$	IF F$LOGICAL(NEWDEV) .NES. "" THEN  GOTO ROOTED
$	WRKDIR = "000000]" + NEWDIR
$	GOTO SEARCH
$!
$ ROOTED:
$	ROOT = F$LOGICAL(NEWDEV)
$	COL = F$LOCATE(":",ROOT)
$	WRKDEV = F$EXTRACT(0,COL,ROOT)
$	ROOT = F$EXTRACT(COL+2,127,ROOT) - "."
$	IF ROOT .EQS. "" THEN ROOT = "000000]"
$	WRKDIR = ROOT + NEWDIR
$!
$ SEARCH:
$	IF .NOT. F$GETDVI(WRKDEV,"EXISTS") THEN  GOTO NOT_MOUNTED
$	IF .NOT. F$GETDVI(WRKDEV,"MNT")    THEN  GOTO NOT_MOUNTED
$	ON WARNING THEN CONTINUE
$!
$	DIRNAME = WRKDEV + ":[" + WRKDIR + ".DIR"
$	OPEN  DIRFILE 'DIRNAME' /ERROR=NOTFOUND
$	CLOSE DIRFILE
$	GOTO TRAVEL
$!
$ NOTFOUND:
$	IF $STATUS .EQ. %X1001829A THEN  GOTO TRAVEL
$	IF NEWDEV .NES. "SYS$SYSROOT" THEN GOTO DIAGNOSTIC
$	DESTINATION = "SYS$SYSDEVICE:" + (DESTINATION - "SYS$SYSROOT:")
$	GOTO TEST						! Try again
$!
$ DIAGNOSTIC:
$	WRITE SYS$OUTPUT "
[1;7m  [",NEWDIR, -
			"] IS NOT ACCESSABLE ON ",NEWDEV,"  [m"
$	GOTO 'DONE'
$!
$ SYNTAX:
$	NEWDEV = DESTINATION
$!
$ NOT_MOUNTED:
$	WRITE SYS$OUTPUT "
[1;7m  ",NEWDEV, -
				" IS NOT ACCESSABLE  [m"
$	GOTO 'DONE'
$!-------------------------------------------------------
$ TRAVEL:
$	SET DEFAULT 'DESTINATION'
$	IF P2.EQS."".OR.P2.EQS."*".OR.P2.EQS."DIR" THEN  GOTO PUSH
$	P1 = P2
$	P2 = P3
$	P3 = ""
$	DONE = "PUSH"
$	GOTO RESTART
$!-------------------------------------------------------
$! Push the current default onto the 8-level default-name stack
$!
$ PUSH:
$	NEWDSK = F$LOGICAL("SYS$DISK")
$	IF F$LOCATE(NEWDSK,SYSDEVICE) .LE. 2 THEN NEWDSK = "SYS$SYSDEVICE:"
$	SD_SP == (1 + SD_SP) .AND. 7
$	SD_SLOT'SD_SP == NEWDSK + F$DIRECTORY()
$!
$	IF F$SEARCH("SDENTRY.COM") .NES. "" THEN  @SDENTRY
$!
$ DONE:
$	WRITE SYS$OUTPUT " "
$	SHOW DEFAULT
$	WRITE SYS$OUTPUT " "
$	IF P2 .EQS. "*" THEN  GOTO STAR
$	IF P2 .EQS. "DIR" THEN  DIR 'P3 'P4 'P5 'P6
$ END:
$	IF VFL THEN  SET VERIFY
