$!
$! If any site-dependent receiver processes are active, these must be
$! killed first.  You should invoke the appropriate command files here.
$!
$! For example, at LBL we need to stop the Hyperchannel receiver process.
$! This is achieved by uncommenting the following command line
$!
$! @dba0:[netmail]stophyp
$!
$! define mstop as a foreign image
$!
$ mstop:==$st_bin:mstop
$ open/read/error=c1 dcl_file st_usr:mstop.exe
$ close dcl_file
$ mstop:==$st_usr:mstop
$ c1:
$!
$! Ask the mail system to stop gracefully
$!
$! Mstop will wait no more than 5 minutes for Delivr to exit.  If Delivr
$! does not exit in that time, an error message is displayed (indicating
$! that ~msg may be left in a corrupted state, and the command file
$! continues
$!
$ mstop -p
$!
$! The rest of this file is to handle the case when the delivery system is
$! wedged for some reason.  Consult the release notes on how to recover
$! from such occurrences
$!
$ save_uic := 'f$user()'
$ save_dir := 'f$directory()'
$ set uic [10,1]
$ on error then continue
$ stop mflush
$ stop mailer
$ stop delivr
$ deassign/system mailer
$ deassign/system delivr
$ deassign/system mflush
$ set uic 'save_uic'
$ set default 'save_dir'
