$	VFL='F$VERIFY(0)'	! CVTLOG.COM
$	SET ON
$	ON CONTROL_Y THEN GOTO END
$!
$!	Command procedure to make CVTLOG look like a
$!	utility known to the system.
$!
$!	The first parameter is the name of the .LOG file to be processed.
$!	The second parameter is the name of the processed file.
$!
$!	If the file type of the first parameter is not
$!	specified, it defaults to ".LOG".
$!
$!	If the second parameter is null or the file type of
$!	the first parameter is ".LOG" (either explicitly or
$!	by default) the processed file name is set the same as
$!	the .LOG file name but with a file type of ".LIS"
$!	residing in the default device and directory.  If the
$!	parameter is null and the first parameter file type
$!	is not ".LOG", a prompt is issued.
$!
$P1CHK:	IF P1 .NES. "" THEN GOTO PARSE
$	INQUIRE/NOPUNCTUATION P1 "_From:	"
$	GOTO P1CHK
$!
$PARSE:
$!
$!	Replace P1 by the fully quallified name of the input file
$!
$	PP = F$PARSE(P1,".LOG")	! Supply ".LOG" as a default
$!
$!	Does this file actually exist?
$!
$	IF PP.EQS."" THEN GOTO NOP1
$	P1 = PP			! In case we need it for the message below
$	PP = F$SEARCH(PP)
$	IF PP.NES."" THEN GOTO P1DONE
$NOP1:
$	WRITE SYS$OUTPUT "''F$MESSAGE(%X912)': ''P1'"
$	GOTO END
$!
$P1DONE:P1 = PP
$	P1N = F$PARSE(P1,,,"NAME")
$	P1T = F$PARSE(P1,,,"TYPE")
$!
$!	Now check the second parameter which names the result file
$!
$	IF P1T.NES.".LOG" .AND. P2.EQS."" THEN -
		INQUIRE/NOPUNCTUATION P1N "_To:  	"
$	P2 = F$PARSE(P2,"''P1N'.LIS")
$!
$RUNIMAGE:
$	ASSIGN/USER_MODE	'P1'	INFILE
$	ASSIGN/USER_MODE	'P2'	OUTFILE
$	ON ERROR THEN CONTINUE
$	RUN	CVTLOG
$END:	IF VFL THEN SET VERIFY
