$ vtl_verify='f$verify(0)'
$!
$! Description:
$!
$! 	Command procedure to invoke the VTL utility.
$!	Contains CTRL/Y exit handling of terminal settings
$!
$! File:	VTL.COM
$! Author:	WE Frank 
$! Date:	August 22, 1983 
$!
$! Modifications: 
$!
$ set noon
$ on control_y then goto cleanup
$ assign/user_mode sys$command sys$input
$ mcr vtl 'p1' 'p2' 'p3' 'p4' 'p5' 'p6' 'p7' 'p8'
$ exit_status=1		! SS$_NORMAL
$ exit	'exit_status'	! 'f$verify(vtl_verify)' Restore verify status
$cleanup:
$ on control_y then continue 	! ignore any additional CTRL/Y's
$ VTterms = %x60	 	! bit mask for /VT1xx terminals
$ term    = F$logical("TT")	! and the terminal we are at.
$ device_type = 'f$getdvi(term,"DEVTYPE")'
$ if ( device_type .and. VTterms ) .eq. VTterms then set terminal /width=80
$ set terminal /noescape	! needed to reset terminal after a cntl/y
$ exit_status=%X611	! SS$_CONTROLY
$ exit	'exit_status'	! 'f$verify(vtl_verify)' Restore verify status
