;
;	Command file to task build the VTL program.
;
VTL/CP/-FP,VTL/-SP/CR=
VTL/LB:VTL:VTLACT:VTLBUF:VTLCMD:VTLERR:VTLFCS:VTLFDB
VTL/LB:VTLFMT:VTLFND:VTLIO:VTLKEY:VTLHDR:VTLNAM:VTLOPE
VTL/LB:VTLPAD:VTLPAR:VTLPOS:VTLRUL:VTLSCR:VTLSET:VTLSHO
VTL/LB:VTLSUB:VTLTBL:VTLTWO:VTLUTL:VTLVMS:VTLWRT
VTL/LB:PARSE:RSXMSG:.TPARS
/
UNITS=6
ASG=SY:1:2:3
ASG=TI:4:5
ASG=LB:6
TASK=...VTL
;
;	The switch mask defines the default VTL switches.  If you don't
;	have the advanced video option, bit B.AVO should be disabled.
;
;	Switch definitions:
;
;	B.NAR	=	1		; List file on narrow screen.
;	B.WIDE	=	2		; List file on wide screen.
;	B.BELL	=	4		; Ring the bell on messages.
;	B.FE	=	10		; Force user to exit at EOF.
;	B.FF	=	20		; Pass form feeds to terminal.
;	B.AVO	=	40		; VT100 with advanced video.
;	B.HDR	=	100		; Display the file header.
;	B.WAIT	=	200		; Wait for user after errors.
;	B.GBL	=	400		; Do global search (not implemented).
;	B.XACT	=	1000		; Do exact search (0 = general).
;	B.PROT	=	2000		; Protect file on deletion.
;	B.SCRB	=	4000		; Scroll both files in split screen.
;
;	The default switch mask:
;
;	002240 = B.PROT!B.WAIT!B.AVO
;
GBLPAT=VTL:SWMASK:002240
//
